#!/bin/sh
# $Id: t-cltbind-2.sh,v 1.9 2011/04/28 17:44:22 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test client IP address binding, selection based on IP= in MAIL
# ----------------------------------------
#

SD=`dirname $0`
THISDIR=`pwd`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

chkcto smtpc COMMERCIAL
chkcto smtpc SC_SESS_FEATS
chkcto smtps SMI_MAILEXT

if test X"`uname`" != "XOSF1"
then
while getopts S:s:V FLAG
do
  case "${FLAG}" in
    S) SKIP="${OPTARG}";;
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

getip2 2

cd ../qmgr || exit 1

${CAT} > ${SMXCNF} <<EOF
smtpc { Log_Level = 13; remote_port=${SNKPORT}; wait_for_server=4;
}
smtps {
	Log_Level = 13;
	daemon_address = localhost:${SRVPORT};
	wait_for_server=4;
}
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
	smtpc {
		source bind0 { ips = { $H2 } }
	}
}
smar { Log_Level = 12; nameserver = ${NS}; }
EOF

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
some.dom	[127.0.0.1]
EOF

# ----------------------------------------
# test: send mail, check whether connect from smtpc to sink comes from right
# address based on IP=
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

CLTIP=1.2.3.4
${CAT} > ${QMGRCONF} <<EOF
smtpc_conf_cltaddr:${CLTIP}	source=bind0;
EOF
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}

if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -Ssender@some.dom -Ruser@some.dom -E 1 -X 1 -A 1 -Z "smtpc2" -d 0 -Y "-d 8" -c "-M IP=${CLTIP}"
then
  if grep "connection from $H2" ${SRVL} >/dev/null
  then
    :
  else
    ERR=true
    $VERBOSE && echo "$0: missing connection from $H2"
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   # test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail, use invalid IP=
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

CLTIP=10.256.3
${CAT} > ${QMGRCONF} <<EOF
smtpc_conf_cltaddr:${CLTIP}	source=bind0;
EOF
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}

if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -Ssender@some.dom -Ruser@some.dom -E 0 -X 0 -A 0 -Z "smtpc2" -d 0 -Y "-d 8" -c "-M IP=${CLTIP}"
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   # test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
