#!/bin/sh
# $Id: t-ss-maxthrds-0.sh,v 1.1 2010/02/15 05:15:11 ca Exp $
#
# ----------------------------------------
# test thread limits for SMTP server
# uses smtp1.sh
# ----------------------------------------
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || exit 1
rm -f ${MT}

TEST=1
# ----------------------------------------
ERR=false
M=40
if ${SHELL} ${SD}/smtp1.sh -E $M -A $M -Z smtpc2 -V '-t 4:10' -t $M -c "-m $M -s $M -d0" -R r@local.host -1
then
    :
else
    ERR=true
fi

if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
