#!/bin/sh
# $Id: t-tls-0.sh,v 1.36 2013/10/21 04:39:03 ca Exp $
# Copyright (c) 2004-2006 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test TLS; check delivered mail
# creates two MTA (one in chkmts, one in qmgr) to use STARTTLS
# run smtpcnf.sh with different parameters
# ----------------------------------------
#

SD=`dirname $0`
THISDIR=`pwd`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

tlsrintro "$@"
# note: this isn't a "tls-reqr" test, but the setup is "good enough"
setuptlsr0 "" "" "dummy	rhs" "" "smtpc { lmtp_rcpts_per_transaction_max=1; }"

# ----------------------------------------
# test: send mail to sink
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -3 lmtpsock -Ssender2@other.dom -Ruser@local.dom -E 0 -X 0 -A 1
then
  chkTLS ${B1}
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
rm -f ${B1}
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi

# ----------------------------------------
# test: send mail to sink: multiple RCPTs
TEST=2
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -3 lmtpsock -Ssender2@other.dom -E 0 -X 0 -A 1 -Ruser@local.dom -Ruser1@local.dom -Ruser2@local.dom
then
  chkTLS ${B1} ${B2} ${B3}
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
else
  rm -f ${B1} ${B2} ${B3}
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


testend rmb
