/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *      All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: confsetpath.h,v 1.6 2014/01/11 02:10:26 ca Exp $
 */

#ifndef SM_CONFSETPATH_H
#define SM_CONFSETPATH_H 1
#include "sm/generic.h"
#include "sm/string.h"

sm_ret_T sm_gen_conf_path(const char *_basedir, const char *_cnfname, const char *_dflt, const char **_pabspath, char **_pabsallocated);

/*
**  Macro to generate map path to either the default or to the name
**  provided by the configuration.
**  If no filename is provided in the configuration (cnfname)
**  then use the default (dflt) but prepend the directory in which the
**  configuration file was found (basedir).
**  The resulting pathname is assigned to abspath.
*/

#define SM_GEN_MAP_PATH(abspath, absallocated, basedir, cnfname, dflt, errlbl)\
	do {							\
		ret = sm_gen_conf_path((basedir), (cnfname), (dflt),	\
					&(abspath), &(absallocated));	\
		if (sm_is_err(ret))					\
			goto errlbl;					\
	} while (0)


#endif /* SM_CONFSETPATH_H */
