/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: pmfdef.h,v 1.11 2013/10/23 22:13:38 ca Exp $
 */

#ifndef PMFDEF_H
#define PMFDEF_H 1

#include "sm/generic.h"
#include "sm/smmts.h"
#include "sm/hdrmoddef.h"
#include "sm/ssmdef.h"

/* pmilter (global) context */
typedef struct pmg_ctx_S	pmg_ctx_T, *pmg_ctx_P;

/* pmilter context per SMTP server */
typedef struct pmss_ctx_S	pmss_ctx_T, *pmss_ctx_P;

/* pmilter session context */
typedef struct pmse_ctx_S	pmse_ctx_T, *pmse_ctx_P;

/* pmilter application context */
typedef struct pmilter_S	pmilter_T, *pmilter_P;

/* stages when to send a macro */
#define PM_SMST_CONNECT		0
#define PM_SMST_EHLO		1
#define PM_SMST_MAIL		2
#define PM_SMST_RCPT		3
#define PM_SMST_DATA		4
#define PM_SMST_DOT		5
#define PM_SMST_MAX		6	/* max number of stages */
#define PM_MACROS_MAX		8	/* max. number of macro per stage */

/* recipient modification, none of these must be 0! */
#define PM_RCPT_ADD	0x01
#define PM_RCPT_DEL	0x02
/* see also smtps/pmilter.h, PM_RCPT_* */

#endif /* ! PMFDEF_H */
