/*
 * Copyright (c) 2010 Claus Assmann
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the license/LICENSE.3C file which can be found at the
 * top level of this source code distribution.
 *
 * $Id: tlsreqcnf.h,v 1.19 2014/01/28 19:08:31 ca Exp $
 */

#ifndef SM_TLSREQCNF_H
#define SM_TLSREQCNF_H 1

#include "sm/generic.h"
#include "sm/tlsstr.h"

#define TLS_MHN_MAX	8

/* TLS requirements configuration context */
struct tlsreq_cnf_S
{
	const char	*tlsreqcnf_common_name;
	const char	*tlsreqcnf_cert_subject;
	const char	*tlsreqcnf_cert_issuer;
	uint		 tlsreqcnf_flags;
	uint		 tlsreqcnf_min_cipher_bits;
	uint		 tlsreqcnf_viol;
	const char	*tlsreqcnf_mhn[TLS_MHN_MAX];
	const char	*tlsreqcnf_root_ca_subjects[TLS_MHN_MAX];
	const char	*tlsreqcnf_cert_fps[TLS_MHN_MAX];
};

#define TLSREQ_FL_VRFD	0x0001u
#define TLSREQ_FL_ENCR	0x0002u
#define TLSREQ_FL_MATCHPREV	0x0004u
#define TLSREQ_FL_NOFB	0x0008u	/* no fallback to clear text */
#define TLSREQ_FL_NOTRICKS	0x0010u	/* do not try TLS "tricks" */

#define TLSREQ_VIOL_PERM	0x0001u
#define TLSREQ_VIOL_TEMP	0x0002u
#define TLSREQ_VIOL_421		0x0004u

#endif /* SM_TLSREQCNF_H */
