/*
 * Copyright (c) 2011 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-mailparse-0.c,v 1.5 2014/04/19 15:55:30 ca Exp $")

#include "sm/debug.h"
#include "sm/memops.h"
#include "sm/io.h"
#include "sm/mail_parse.h"

int
main(int argc, char **argv)
{
	int err, c;
	uchar *domain, *user;

	while ((c = getopt(argc, argv, "h")) != -1) {
		switch (c) {
#if 0
		  default:
			usage(argv[0]);
			return(1);
#endif
		}
	}

	rfc2822_init();
	if (argc <= 1) {
		char from[256];

		(void) strlcpy(from, "user@example.net", sizeof(from));
		err = rfc2822_mailbox_split(from, &user, &domain);
		if (!err)
			sm_io_fprintf(smioerr, "user: '%s'\ndomain: '%s'\n", user, domain);
		else
			sm_io_fprintf(smioerr, "ERROR: %s\n", argv[c]);
	}
	for (c = 1; c < argc; c ++) {
		err = rfc2822_mailbox_split((uchar *)argv[c], &user, &domain);
		if (!err)
			sm_io_fprintf(smioerr, "user: '%s'\ndomain: '%s'\n", user, domain);
		else
			sm_io_fprintf(smioerr, "ERROR: %s\n", argv[c]);
	}
	return 0;
}
