#!/bin/sh
# $Id: t-restart-0.sh,v 1.15 2013/12/22 15:38:17 ca Exp $
# Copyright (c) 2004 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test restart functionality of mcp
# ----------------------------------------

L1=restart.log
L2=restart2.log
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
. ${SD}/common.sh

rm -f ${PIDS} ${OUT} ${PIDF1} ${PIDF2} ${L1} ${L2}

cat > ${CONF} <<EOF
restart {
	start_action = wait;
	processes_min = 1;
	processes_max = 1;
	user = ${USER};
	restart_dependencies = {restart2};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF1} -f ${R1} -n 3 -VV";
}
restart2 {
	start_action = wait;
	processes_min = 1;
	processes_max = 1;
	user = ${USER};
	path = ./t-restart;
	arguments = "t-restart -p ${PIDF2} -f ${R2} -n 2 -VV";
}
EOF

echo 0 > ${R1}
echo 0 > ${R2}
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

waitforfile ${PIDF1}

CNT=2
if test -s ${PIDF1}
then
  PIDR=`cat ${PIDF1}`
  kill -HUP ${PIDR}
  sleep 5
  for F in ${R1} ${R2}
  do
    if test -s ${F}
    then
      C=`cat ${F}`
      if test ${C} -ne ${CNT}
      then
        ${VERBOSE} && echo "counter ${F} wrong: got ${C}, expected ${CNT}"
        ERRS=`expr ${ERRS} + 1 `
      fi
    else
      ${VERBOSE} && echo "missing ${F}"
      ERRS=`expr ${ERRS} + 1 `
    fi
  done
fi

stopit
testend
